﻿@using Ito.Software.Technical.Test.Domain.Dtos.Customer
@using Ito.Software.Technical.Test.Domain.Dtos.Order
@using Ito.Software.Technical.Test.Domain.Dtos.Product
<ModalComponent ButtonText="Add Order"
                ModalTitle="New order"
                OkButtonText="Save order"
                IsOkButtonSubmitType="true"
                FormId="AddFormId">
    <EditForm id="@AddFormId" Model="@OrderDto" OnValidSubmit="@HandleValidSubmit">
        <DataAnnotationsValidator />
        <ValidationSummary />

        <div class="mb-3">
            <label for="customer" class="form-label">Customer</label>
            @if (Customers.Count > 0)
            {
                <InputSelect id="customer" @bind-Value="OrderDto.CustomerId" class="form-select">
                    @foreach (CustomerDto customer in Customers)
                    {
                    <option value="@customer.Id">@customer.Name</option>
                    }
            </InputSelect>
            }
            else
            {
                <p for="customer" class="form-label"><i>Loading customers...</i></p>
            }
        </div>
        <div class="row">

            <div class="mb-3 col-md-6">
                <label for="orderNumber" class="form-label">Order number</label>
                <InputText id="orderNumber" @bind-Value="OrderDto.OrderNumber" class="form-control" />
            </div>

            <div class="mb-3 col-md-6">
                <label for="orderDate" class="form-label">Order date</label>
                <InputDate id="orderDate" @bind-Value="OrderDto.OrderDate" class="form-control" />

            </div>

        </div>

        <div class="mb-3">
            <label for="orderDate" class="form-label">Total amount</label>
            <InputNumber id="orderDate" contenteditable="false" @bind-Value="OrderDto.TotalAmount" class="form-control" />
        </div>

        <hr />

        <div class="mb-3">
            <div class="row">
                <div class="col-md-4">
                    <label for="customer" class="form-label">Product</label>
                    @if (Products.Count > 0)
                    {
                        <select id="product" class="form-select" @onchange="OnProductChanged">
                            <option value="" selected></option>
                            @foreach (ProductDto product in Products)
                            {
                                <option value="@product.Id">@product.Name</option>
                            }
                        </select>
                    }
                    else
                    {
                        <p for="customer" class="form-label"><i>Loading products...</i></p>
                    }
                </div>
                <div class="col-md-3">
                    <label for="customer" class="form-label">Unit price</label>
                    <InputNumber @bind-Value="@ProductSelected.UnitPrice" class="form-control" />
                </div>
                <div class="col-md-2">
                    <label for="customer" class="form-label">Qty</label>
                    <InputNumber id="qty" @bind-Value="Qty" class="form-control" />
                </div>
                <div class="col-md-3">
                    <label for="customer" class="form-label">_</label>
                    <button type="button" class="btn btn-success form-control" @onclick="AddToOrder">+</button>
                </div>

            </div>
        </div>
    </EditForm>
    <table class="table">
        <thead>
            <tr>
                <th>Product Id</th>
                <th>Name</th>
                <th>Qty</th>
                <th>Unit Price</th>
                <th>Actions</th>
            </tr>
        </thead>
        <tbody>
            @if (OrderDto.OrderItems.Count > 0)
            {
                @foreach (OrderItemDto item in OrderDto.OrderItems)
                {
                    <tr>
                        <td>
                            <label class="form-label">@item.ProductId</label>
                        </td>
                        <td>
                            <label class="form-label">@item.ProductName</label>
                        </td>
                        <td>
                            <label class="form-label">@item.Quantity</label>
                        </td>
                        <td>
                            <label class="form-label">@item.UnitPrice</label>
                        </td>
                        <td>
                            -
                        </td>
                    </tr>
                }
            }
            else
            {
                <tr>
                    <td colspan="5">
                        <div class="d-flex justify-content-center">
                            <h4>No items</h4>
                        </div>
                    </td>
                </tr>
            }
        </tbody>
    </table>
</ModalComponent>
